<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2012 - 2015 All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);
if (version_compare(PHP_VERSION, '5.3.1', '<'))
{
	die('Your host needs to use PHP 5.3.1 or higher to run this version of Joomla!');
}
define('_JEXEC', 1);
defined( '_JEXEC' ) or die( 'Restricted access' );
define('DS', DIRECTORY_SEPARATOR);
$dirname=str_ireplace(DS.'modules'.DS.'mod_paymybill'.DS.'return','', dirname(__FILE__));
if (file_exists($dirname.DS.'defines.php'))
{
	include_once $dirname.DS.'defines.php';
}
if (!defined('_JDEFINES'))
{
	define('JPATH_BASE', $dirname);
	require_once JPATH_BASE.DS.'includes/defines.php';
}
require_once JPATH_BASE.DS.'includes/framework.php';
// Mark afterLoad in the profiler.
JDEBUG ? $_PROFILER->mark('afterLoad') : null;
// Instantiate the application.
$app = JFactory::getApplication('site');
require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."helper.php");
$PMBHelper = new PMBHelper();
$id=isset($_GET[ "ORDER" ])?$_GET[ "ORDER" ]+0:0;
if($id==0)
  die('Lipsa comanda');
$order_id="";
$db=JFactory::getDbo();
$sql="select order_id from #__paymybill where id=".$id;
$db->setQuery($sql);
$res=$db->loadObject();
if(isset($res->order_id) && $res->order_id!="")
{
  $order_id=$res->order_id;
}
else
{
  die('Comanda lipseste');
}
$module_id=0;
$tarr=explode("-",$order_id);
$module_id=$tarr[1]+0;
if($module_id==0)
  die('Lipsa modul');
$params=$PMBHelper->getWorkingModParams($module_id);
require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
$pmbf=new PMBFunctions();
$details=$pmbf->getOrderDetails($order_id);
$sql="select * from #__paymybill where order_id='".$db->escape($order_id)."' AND APPROVAL != '' AND RRN_Sales = '' AND RRN_Reversal = ''";
$db->setQuery($sql);
$order=$db->loadObject();
if(isset($order->id) && $order->id>0)
{
  $mode=$order->mode;
  
  $BT_KEY=$params['romcard_BT_KEY'];
  $BT_TERMINAL=$params['romcard_TERMINAL'];
  $romcard_MERCH_NAME=$params['romcard_MERCH_NAME'];
  
  $romcard_URL="https://www.secure11gw.ro/portal/cgi-bin/";//live
	
	if($mode=='TEST')
  {
    $romcard_URL="https://www.activare3dsecure.ro/teste3d/cgi-bin/";//test
  }
  
  $sData = "";
	$sAction = $_GET[ "ACTION" ];
	AddField( $sData, $sAction );
	$sRC = $_GET[ "RC" ];
	AddField( $sData, $sRC );
	
	$sMessage = $_GET[ "MESSAGE" ];
	AddField( $sData, $sMessage );
	$sTrType = $_GET[ "TRTYPE" ];
	AddField( $sData, $sTrType );
	
	$sAmount = $_GET[ "AMOUNT" ];
	AddField( $sData, $sAmount );
	
	$sCurrency = $_GET[ "CURRENCY" ];
	AddField( $sData, $sCurrency );
	
	$sOrder = $_GET[ "ORDER" ];
	AddField( $sData, $sOrder );
	
	$sRRN = $_GET[ "RRN" ];
	AddField( $sData, $sRRN );
	
	$sIntRef = $_GET[ "INT_REF" ];
	AddField( $sData, $sIntRef );
	
	$sTimeStamp = $_GET[ "TIMESTAMP" ];
	AddField( $sData, $sTimeStamp );
	
 	$sNonce = $_GET[ "NONCE" ];
	AddField( $sData, $sNonce );
	
	$sSign = $_GET[ "P_SIGN" ];
	$sHash = CalculateHash( $sData, $BT_KEY );
	if( $sSign != $sHash )
	{
		// Date invalide
		die( "Mesaj invalid" );
	}
  
  // Confirmare pentru tranzactie de preautorizare
	if( $sTrType == 21 )
	{
		if( $sAction == 0 )
		{
			$iId = intval( $sOrder );
			$sql="update #__paymybill set RRN_Sales='".$db->escape($sRRN)."', INT_REF_Sales='".$db->escape($sIntRef)."',
      `status`='approved',
      mdate='".time()."'
      where id=".$iId;
      $db->setQuery($sql);
      $db->query();
      //send the reversal mail
      $pmbf->sendAdminReversalActionsMail($params,$details);
      echo "<strong><font color='#4CC417'>Tranzactia a fost APROBATA</font></strong>";
		}
		else
		{
			echo "Eroare la procesarea tranzactiei ! Plata nu a fost efectuata !";
		}
	}
	else
	{
		echo "Apel eronat !";
	}
}
else
{
  die('Tranzactia nu exista, nu a fost aprobata, sau a fost deja incasata.');
}
function AddField( &$sData, $sFieldValue )
{
	if( strlen( $sFieldValue ) == 0 )
	{
		$sData .= "-";
	}
	else
	{
		$sData .= strlen( $sFieldValue ) . $sFieldValue;
	}
}
function CalculateHash( $sData, $BT_KEY )
{
	return strtoupper( hash_hmac( "sha1", $sData, pack( 'H*', $BT_KEY ) ) );
}
?>